package ru.dbotthepony.mc.otm.datagen.textures

import net.neoforged.neoforge.common.data.SpriteSourceProvider
import net.neoforged.neoforge.data.event.GatherDataEvent
import ru.dbotthepony.mc.otm.client.render.ColorizedSpriteSource
import ru.dbotthepony.mc.otm.datagen.DataGen
import ru.dbotthepony.mc.otm.datagen.modLocation

class ColorizedSpritesProvider(event: GatherDataEvent) : SpriteSourceProvider(event.generator.packOutput, event.lookupProvider, DataGen.MOD_ID, event.existingFileHelper) {
	override fun gather() {
		with(atlas(BLOCKS_ATLAS)) {
			listOf(
				"block/android_charger",
				"block/android_station_base",
				"block/batterybank_frame",
				"block/chemical_generator",
				"block/cobblestone_generator",
				"block/decorative/computer_base",
				"block/decorative/computer_screen",
				"block/drive_viewer",
				"block/electric_furnace",
				"block/electric_furnace_offline",
				"block/energy_counter",
				"block/energy_servo",
				"block/essence_storage",
				"block/induction_furnace",
				"block/induction_furnace_offline",
				"block/item_monitor",
				"block/matter_bottler",
				"block/matter_decomposer",
				"block/matter_panel",
				"block/matter_reconstructor",
				"block/matter_recycler",
				"block/matter_replicator_base",
				"block/matter_replicator_halted",
				"block/matter_replicator",
				"block/matter_replicator_offline",
				"block/matter_scanner",
				"block/mattercapacitorbank_frame",
				"block/plate_press",
				"block/plate_press2",
				"block/powered_smoker_base",
				"block/powered_smoker_interior_0",
				"block/powered_smoker_interior_1",
				"block/powered_smoker_interior_2",
				"block/decorative/star_chair",
				"block/storage_power_supplier",
				"block/water_source"
			).forEach {
				addSource(
					ColorizedSpriteSource(modLocation(it), modLocation(it).withSuffix("_mask"), modLocation(it)).trackGeneratedTextures(existingFileHelper)
				)
			}

			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/crates/crate_borderless_colorless"),
					modLocation("block/decorative/crates/crate_frame"),
					modLocation("block/decorative/crates/crate"), "_", true, false
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/crates/crate_borderless_colorless"),
					modLocation("block/decorative/crates/crate_borderless_colorless"),
					modLocation("block/decorative/crates/crate_borderless"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)

			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_block"),
					modLocation("block/decorative/tritanium_block_colorless"),
					modLocation("block/decorative/tritanium_block"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_pillar"),
					modLocation("block/decorative/tritanium_pillar_colorless"),
					modLocation("block/decorative/tritanium_pillar"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_striped_block_base"),
					modLocation("block/decorative/tritanium_striped_block_colorless_stripe"),
					modLocation("block/decorative/stripe/tritanium_striped_block"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_striped_block_colorless_base"),
					modLocation("block/decorative/tritanium_striped_block_colorless_stripe"),
					modLocation("block/decorative/stripe/tritanium_striped_block"), "_", true, true
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_door_base_top"),
					modLocation("block/decorative/tritanium_door_color_top"),
					modLocation("block/decorative/tritanium_door_top"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_door_base_bottom"),
					modLocation("block/decorative/tritanium_door_color_bottom"),
					modLocation("block/decorative/tritanium_door_bottom"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/tritanium_trapdoor_overlay"),
					modLocation("block/decorative/tritanium_trapdoor_colorless"),
					modLocation("block/decorative/tritanium_trapdoor"), "_"
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/vent_colorless"),
					modLocation("block/decorative/vent_overlay"),
					modLocation("block/decorative/vent"), "_", true, false
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("block/decorative/vent_alternative_colorless"),
					modLocation("block/decorative/vent_alternative_overlay"),
					modLocation("block/decorative/vent_alternative"), "_", true, false
				).trackGeneratedTextures(existingFileHelper)
			)

			addSource(
				ColorizedSpriteSource(
					modLocation("item/minecart_cargo_crate_colorless"),
					modLocation("item/minecart_cargo_crate_nopaint"),
					modLocation("item/minecart_cargo_crate"), "_", true, false
				).trackGeneratedTextures(existingFileHelper)
			)
			addSource(
				ColorizedSpriteSource(
					modLocation("item/tritanium_door_colorless"),
					modLocation("item/tritanium_door_overlay"),
					modLocation("item/tritanium_door"), "_", true, false
				).trackGeneratedTextures(existingFileHelper)
			)
		}
	}
}
